
PROCEDURE RotateRight(Ptr)
;16-Bit Rotation, Carry wird eingeschoben
  MOV     R6,A    ;Save Accu
  INC R1          ;R1 points to the LSB
  MOV     A,@R1   ;get MSB
  RRC     A
  MOV     @R1,A   ;Result MSB
  DEC     R1      ;point at LSB
  MOV     A,@R1   ;get it
  RRC     A
  MOV     @R1,A   ;Store result LSB
  MOV     A,R6    ;restore Accu
EndProc

PROCEDURE ShiftRight(Ptr)
;16-Bit Schieben0 wird eingeschoben
  MOV     R6,A    ;Save Accu
  INC R1          ;R1 points to the LSB
  MOV     A,@R1   ;get MSB
  CLC
  RRC     A
  MOV     @R1,A   ;Result MSB
  DEC     R1      ;point at LSB 
  MOV     A,@R1   ;get it
  RRC     A
  MOV     @R1,A   ;Store result LSB
  MOV     A,R6    ;restore Accu
EndProc

PROCEDURE RotateLeft(Ptr)
;16-Bit Rotation, Carry wird eingeschoben
  MOV     R6,A    ;Save Accu
  INC R1          ;R1 points to the LSB
  MOV     A,@R1   ;get MSB
  RLC     A
  MOV     @R1,A   ;Result MSB
  DEC     R1      ;point at LSB
  MOV     A,@R1   ;get it
  RLC     A
  MOV     @R1,A   ;Store result LSB
  MOV     A,R6    ;restore Accu
EndProc

PROCEDURE ShiftLeft(Ptr)
;16-Bit Schieben0 wird eingeschoben
  MOV     R6,A    ;Save Accu
  INC R1          ;R1 points to the LSB
  MOV     A,@R1   ;get MSB
  CLC
  RLC     A
  MOV     @R1,A   ;Result MSB
  DEC     R1      ;point at LSB
  MOV     A,@R1   ;get it
  RLC     A
  MOV     @R1,A   ;Store result LSB
  MOV     A,R6    ;restore Accu
EndProc
