PROCEDURE BinToBCD
; Converts an 8 Bit Binary value to BCD
; The Binary value is in A
; R1 is pointer to the packed BCD string storage
; DESTROYS R0, R1, R4, R5, R6
;
  XCH     A,R1
  MOV     R0,A
  XCH     A,R1
  MOV     R4,#2
:BINLP1:
  MOV     @R0,#0
  INC     R0
  DJNZ    R4,BINLP1:
  MOV     R6,#8
:BINLP2:
  CLR     C
  RLC     A
  XCH     A,R1
  MOV     R0,A
  XCH     A,R1
  MOV     R4,#2
  MOV     R5,A
:BINLP3:
  MOV     A,@R0
  ADDC    A,@R0
  DA      A
  MOV     @R0,A
  INC     R0
  DJNZ    R4,BINLP3:
  MOV     A,R5
  JC      BINERROR:
  DJNZ    R6,BINLP2:
  CLR     C
:BINERROR:
EndProc ; C set if error termination


